
;*************************************************************************
;  
;  : ATmega8-16PU, 
;    - 16 
;  Copywrite (C) Darkstar 12-11-2015, ver.1.20
;*************************************************************************
;***** Specify Device
.device ATmega8

; *****    ***************************************
.def	mp	= R16		;   mp

; *****    ***************************************
.def	xp	= R17		;   xp

; *****      
   .def	B2D1High	  = R20	;    BIN -> BCD
   .def	B2D1Low	  = R21	;
   .def	B2D2High	  = R0	;
   .def	B2D2Low	  = R1	;

   .def	FREQ_1Hz	  = R22	; 1 
   .def	FREQ_10Hz   = R23	; 10 
   .def	FREQ_100Hz  = R24	; 100 
   .def	FREQ_1kHz   = R25	; 1 
   .def	FREQ_10kHz  = R26	; 10 
   .def	FREQ_100kHz = R27	; 100 
   .def	FREQ_1MHz   = R28	; 1 

.MACRO OUTI		;     
   LDI mp,@1
   OUT @0,mp
.ENDMACRO

.DSEG			;  .     
.org   0x060		;   0060    
;**************************************************************************
;     
			;     
   FrInd_H1:   .byte 1	; 1 
   FrInd_H10:  .byte 1	; 10 
   FrInd_H100: .byte 1	; 100 
   FrInd_K1:   .byte 1	; 1 
   FrInd_K10:  .byte 1	; 10 
   FrInd_K100: .byte 1	; 100 
   FrInd_M1:   .byte 1	; 1 
   FrInd_M10:  .byte 1	; 10 

   FrInd_0:   .byte 1	;
   FrInd_1:   .byte 1	;
   FrInd_2:   .byte 1	;

.CSEG			;  
; *****    **************************************
.org   0x000			;   0000  
				;   
   rjmp	RESET		; Reset Handler
   reti ;rjmp EXT_INT0	; IRQ0 Handler
   reti ;rjmp EXT_INT1	; IRQ1 Handler
   reti ;rjmp TIM2_COMP	; Timer2 Compare Handler
   reti ;rjmp TIM2_OVF	; Timer2 Overflow Handler
   reti ;rjmp TIM1_CAPT	; Timer1 Capture Handler
   rjmp	TIM1_COMPA	; Timer1 CompareA Handler
   reti ;rjmp TIM1_COMPB	; Timer1 CompareB Handler
   reti ;rjmp TIM1_OVF	; Timer1 Overflow Handler
   OUT	TCNT0,R2		;  0 = 156
   ADIW	R30:R31,1		; R30:R31 = R30:R31+1
   reti ;rjmp SPI_STC	; SPI Transfer Complete Handler
   reti ;rjmp USART_RXC	; USART RX Complete Handler
   reti ;rjmp USART_UDRE	; UDR Empty Handler
   reti ;rjmp USART_TXC	; USART TX Complete Handler
   reti ;rjmp ADC		; ADC Conversion Complete Handler
   reti ;rjmp EE_RDY		; EEPROM Ready Handler
   reti ;rjmp ANA_COMP	; Analog Comparator Handler
   reti ;rjmp TWSI		; Two-wire Serial Interface Handler
   reti ;rjmp SPM_RDY	; Store Program Memory Ready Handler
.org   0x015		;    
			;   0013    

BinToBCD:			;       BCD-
			; R24:R25 -   (   )
			; R0:R1   -   
			; mp -  
   MOV	B2D1High,R31
   MOV	B2D1Low, R30

   CLR	FREQ_1Hz
   CLR	FREQ_10Hz
   CLR	FREQ_100Hz
   CLR	FREQ_1kHz   
   CLR	FREQ_10kHz
   CLR	FREQ_100kHz
   CLR	FREQ_1MHz

   LDI	mp,HIGH(10000)	;  10000
   MOV	B2D2High,mp	; R0 = 0x27
   LDI	mp,LOW(10000)
   MOV	B2D2Low,mp	; R1 = 0x10
   rcall	BinToBCD10
   mov	FREQ_1MHz,mp	;   1MHz

   LDI	mp,HIGH(1000)	;  1000
   MOV	B2D2High,mp
   LDI	mp,LOW(1000)
   MOV	B2D2Low,mp
   rcall	BinToBCD10
   mov	FREQ_100kHz,mp	;   100kHz   

   LDI	mp,HIGH(100)	;  100
   MOV	B2D2High,mp
   LDI	mp,LOW(100)
   MOV	B2D2Low,mp
   rcall	BinToBCD10
   mov	FREQ_10kHz,mp	;   10kHz

   LDI	mp,HIGH(10)	;  10
   MOV	B2D2High,mp
   LDI	mp,LOW(10)
   MOV	B2D2Low,mp
   rcall	BinToBCD10
   mov	FREQ_1kHz,mp	;   1kHz

   mov	FREQ_100Hz,B2D1Low	;   100Hz

   CLR	B2D1High
   MOV	B2D1Low,xp
   LDI	mp,HIGH(10)	;  10
   MOV	B2D2High,mp
   LDI	mp,LOW(10)
   MOV	B2D2Low,mp
   rcall	BinToBCD10
   mov	FREQ_10Hz,mp	;   10Hz

   mov	FREQ_1Hz,B2D1Low	;   1Hz
   

FREQADD1:
   CPI	FREQ_1Hz,10	;  FREQ_1Hz  10
   BRLO	FREQADD10		;    
			;   
   SUBI	FREQ_1Hz,10	; FREQ_1Hz =  FREQ_1Hz - 10
   INC	FREQ_10Hz		; FREQ_10Hz = FREQ_10Hz + 1
FREQADD10:
   CPI	FREQ_10Hz,10	;  FREQ_10Hz  10
   BRLO	FREQADD100	;    
			;   
   SUBI	FREQ_10Hz,10	; FREQ_10Hz =  FREQ_10Hz - 10
   INC	FREQ_100Hz	; FREQ_100Hz = FREQ_100Hz + 1
FREQADD100:
   CPI	FREQ_100Hz,10	;  FREQ_100Hz  10
   BRLO	FREQADD1k		;    
			;   
   SUBI	FREQ_100Hz,10	; FREQ_100Hz =  FREQ_100Hz - 10
   INC	FREQ_1kHz		; FREQ_1kHz = FREQ_1kHz + 1
FREQADD1k:
   CPI	FREQ_1kHz,10	;  FREQ_1kHz  10
   BRLO	FREQADD10k	;    
			;   
   SUBI	FREQ_1kHz,10	; FREQ_1kHz =  FREQ_1kHz - 10
   INC	FREQ_10kHz	; FREQ_10kHz = FREQ_10kHz + 1
FREQADD10k:
   CPI	FREQ_10kHz,10	;  FREQ_10kHz  10
   BRLO	FREQADD100k	;    
			;   
   SUBI	FREQ_10kHz,10	; FREQ_10kHz =  FREQ_10kHz - 10
   INC	FREQ_100kHz	; FREQ_100kHz = FREQ_100kHz + 1
FREQADD100k:
   CPI	FREQ_100kHz,10	;  FREQ_100kHz  10
   BRLO	FREQADD1M		;    
			;   
   SUBI	FREQ_100kHz,10	; FREQ_10kHz =  FREQ_10kHz - 10
   INC	FREQ_1MHz		; FREQ_1MHz = FREQ_1MHz + 1
FREQADD1M:
   CPI	FREQ_1MHz,10	;  FREQ_1MHz  10
   BRLO	FREQADD10M	;    
			;   
   SUBI	FREQ_1MHz,10	; FREQ_1MHz =  FREQ_1MHz - 10
   ;INC	FREQ_10M		; FREQ_10MHz = FREQ_10MHz + 1
FREQADD10M:
   RET

BinToBCD10:   
   CLR	mp		;     
BTB10:
   CP	B2D1High,B2D2High	; xx = R25 - R0
   BRCS	BTB30		;  |R25|<|R0|,     
   BRNE	BTB20
   CP	B2D1Low,B2D2Low	; xx = R24 - R1
   BRCS	BTB30		;  |R24|<|R1|,     
BTB20:
   SUB	B2D1Low,B2D2Low	; R24 = R24 - R1
   SBC	B2D1High,B2D2High	; R25 = R25 - R0
   INC	mp		;    
   RJMP	BTB10		;  
BTB30:
   RET
   


;**************************************************************************
;  	
TIM1_COMPA:
		;    -1
   IN 	xp,TCNT0	;    0
   CLI		;        
   OUTI	TCCR0, 0b00000000	;   -0
   OUTI	TCCR1B,0b00000000	;   -1

   SUBI	xp,156	; xp = TCNT0 - 156 (162  100)
   
   STS	FrInd_0,xp
   STS	FrInd_1,R30
   STS	FrInd_2,R31  

   RCALL	BinToBCD
   
   ;STS	FrInd_H1,FREQ_1Hz
   STS	FrInd_H10,FREQ_1Hz
   STS	FrInd_H100,FREQ_10Hz   
   STS	FrInd_K1,FREQ_100Hz
   STS	FrInd_K10,FREQ_1kHz    
   STS	FrInd_K100,FREQ_10kHz 
   STS	FrInd_M1,FREQ_100kHz   
   STS	FrInd_M10,FREQ_1MHz

   rcall	SUB_FREQ_LCD_OUT	;     -

   CLR	R30
   CLR	R31

   OUTI	TCNT1H,0b00000000	;  1
   OUTI	TCNT1L,0b00000000	;
   OUTI	TCNT0,156	;  0 = 156
   SEI

   OUTI	TCCR1B,0b01000101	;   -1
   OUTI	TCCR0,0b00000110	;   -0 
   reti



TIM0_OVF:
			;    -0
   OUTI	TCNT0,156		;  0 = 156
   ADIW	R30:R31,1		; R30:R31 = R30:R31+1
   RETI

;**************************************************************************




;**************************************************************************
RESET:				;        *
   LDI	mp,LOW(RAMEND)	;*******************************
   OUT	SPL,mp		;  16-
   LDI	mp,HIGH(RAMEND)	;   SPH:SPL
   OUT	SPH,mp		;

   LDI mp,156		;   R2   TCNT0 = 156 
   MOV R2,mp
   
   CLR	FREQ_1Hz
   CLR	FREQ_10Hz
   CLR	FREQ_100Hz
   CLR	FREQ_1kHz   
   CLR	FREQ_10kHz
   CLR	FREQ_100kHz
   CLR	FREQ_1MHz


				;      1 
	OUTI	TCCR1A,0b00000000	; 
	OUTI	TCCR1B,0b01000101	;  f/256 = 100, f/1024 = 101
	OUTI	TCNT1H,0b00000000	;  1
	OUTI	TCNT1L,0b00000000	;	
	OUTI	OCR1AH,0x03D	;     = 
	OUTI	OCR1AL,0x008	; 6250 = 18 6A, 15625 = 3D 09
	OUTI	TIMSK,0b00010000	;  1     

				;     
	OUTI	TCCR0,0b00000110	;  0
	OUTI	TCNT0,156		;  0 = 156
	OUTI	TIMSK,0b00010001	;  0  1


		;   -
		;  D:
	OUTI	DDRD,0b10000000	; 0-, 1-
	OUTI	PORTD,0b11111111	; 
		;  :
	ldi	mp,0b11000000	;      B
	out	DDRB,mp		; 0-, 1-
	ldi	mp,0b11111111	;
	out	PORTB,mp		;    1,    1
				;
		;  :
			; P0 -   -  DB7
			; P1 -   -  DB6
			; P2 -   -  DB5
			; P3 -   -  DB4
			; P4 -   -  RS
			; P5 -   -  E
			; P6 - RESET	
	ldi	mp,0b11111111	;      C
	out	DDRC,mp		; 0-, 1-
				;
	ldi	mp,0b00000000	;
	out	PORTC,mp		;   C  0

	
;**************************************************************************
PROG_START:			;  

	rcall	SUB_LCD_INIT	;  -
	rcall	SUB_FREQ_LCD_OUT	;     -			
	SEI			;   

PROG_LOOP:

   rjmp	PROG_LOOP		;  





SUB_FREQ_LCD_OUT:
; **********************************************************************
; *     -                          *
; *       (  - - )                        *
; *  :
; * R24, R25, R16(mp), X


	ldi	mp,0b10000000	;     , AC DDRAM = 000
	rcall	LCD_command_out
	ldi	mp,0x3E		;  ">"
	rcall	LCD_data_out
	ldi	mp,0x20		;  " "
	rcall	LCD_data_out

	ldi	xp,0x30		;   
	
	LDS	mp,FrInd_M10	; 10 
	ADD	mp,xp
	rcall	LCD_data_out

	LDS	mp,FrInd_M1	; 1 
	ADD	mp,xp
	rcall	LCD_data_out
	
	ldi	mp,0x2E		;  "."
	rcall	LCD_data_out	

	LDS	mp,FrInd_K100	; 100 
	ADD	mp,xp
	rcall	LCD_data_out

	LDS	mp,FrInd_K10	; 10 
	ADD	mp,xp
	rcall	LCD_data_out

	LDS	mp,FrInd_K1	; 1 
	ADD	mp,xp
	rcall	LCD_data_out
	
	ldi	mp,0x2E		;  "."
	rcall	LCD_data_out

	LDS	mp,FrInd_H100	; 100 
	ADD	mp,xp
	rcall	LCD_data_out

	LDS	mp,FrInd_H10	; 10 
	ADD	mp,xp
	rcall	LCD_data_out

	;LDS	mp,FrInd_H1	; 1 
	;ADD	mp,xp
	;rcall	LCD_data_out

	ldi	mp,0x20		;  " "				
	rcall	LCD_data_out				
	ldi	mp,0x01		;   "" 
	rcall	LCD_data_out
	ldi	mp,0x02		;   "" 
	rcall	LCD_data_out
	ldi	mp,0x03		;   ""
	rcall	LCD_data_out

	ldi	mp,0x20		;  " "
	rcall	LCD_data_out
		
	ret			

;----------------------------------




SUB_LCD_INIT:
; **********************************************************************
; *   - HD44870                      *
; *       (4-  )                                       *

.equ	LCDPort = PORTC		;  
.equ	LCD_E   = 5		;     E
.equ	LCD_RS  = 4 		;   / RS
				;  RW  = 0 (    )
.equ	LCD_D4  = 3 		;   DB4
.equ	LCD_D5  = 2 		;   DB5
.equ	LCD_D6  = 1 		;   DB6
.equ	LCD_D7  = 0 		;   DB7

	cbi	LCDPort,LCD_RS	;RS=0 -    
	cbi	LCDPort,LCD_E	;E=0
	rcall	LCD_zadb		; 15 
;  Function set - 4 bit mode (0010)
	cbi	LCDPort,LCD_D7	;DB7=0 -    4- 
	cbi	LCDPort,LCD_D6	;DB6=0
	sbi	LCDPort,LCD_D5	;DB5=1
	cbi	LCDPort,LCD_D4	;DB4=0
	sbi	LCDPort,LCD_E	;E=1 -    
	rcall	LCD_zadm		; 0,5 
	cbi	LCDPort,LCD_E	;E=0
	rcall	LCD_zadb		; 15 
				;     4- :
	ldi	mp,0b00101000	; - 4- ,  ,   57 
	rcall	LCD_command_out
	rcall	LCD_zadb		; 15 
;  Display ON
	ldi	mp,0b00001100	; ,   
	rcall	LCD_command_out
;  Clear Display
	ldi	mp,0b00000001	; 
	rcall	LCD_command_out
	rcall	LCD_zadb		; 15 
;  Entry Mode Set
	ldi	mp,0b00000110	;  
	rcall	LCD_command_out
	rcall	LCD_zadm		; 0,5 
;  CGRAM   ""
	ldi	mp,0b01001000	;  CGRAM,  = 00 1000 = 8
	rcall	LCD_command_out	; ""
	ldi	mp,0b00010001	;-1
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-2
	rcall	LCD_data_out
	ldi	mp,0b00010100	;-3
	rcall	LCD_data_out
	ldi	mp,0b00011100	;-4
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-5
	rcall	LCD_data_out
	ldi	mp,0b00010001	;-6
	rcall	LCD_data_out
	ldi	mp,0b00010001	;-7
	rcall	LCD_data_out
	ldi	mp,0b00000000	;-8
	rcall	LCD_data_out

	ldi	mp,0b01010000	;  CGRAM,  = 01 0000 = 16
	rcall	LCD_command_out	; ""
	ldi	mp,0b00011111	;-1
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-2
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-3
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-4
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-5
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-6
	rcall	LCD_data_out
	ldi	mp,0b00010000	;-7
	rcall	LCD_data_out
	ldi	mp,0b00000000	;-8
	rcall	LCD_data_out
	
	ldi	mp,0b01011000	;  CGRAM,  = 01 1000 = 24
	rcall	LCD_command_out	; ""
	ldi	mp,0b00000000	;-1
	rcall	LCD_data_out
	ldi	mp,0b00000000	;-2
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-3
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-4
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-5
	rcall	LCD_data_out
	ldi	mp,0b00010010	;-6
	rcall	LCD_data_out
	ldi	mp,0b00011111	;-7
	rcall	LCD_data_out
	ldi	mp,0b00000001	;-8
	rcall	LCD_data_out

	ret
;----------------------------------






;**********************************
;  
;
;**********************************



LCD_command_out:
	cbi	LCDPort,LCD_RS	;RS=0 -  
	cbi	LCDPort,LCD_E	;E=0 - 
	rcall	LCD_out
	ret

;      mp   
LCD_data_out:
	sbi	LCDPort,LCD_RS	;RS=1 -  
	cbi	LCDPort,LCD_E	;E=0  - 
	rcall	LCD_out
	ret

;      4- 
LCD_out:
				;     
				;DB7
	sbrs	mp,7		; mp(7)=1,  
	cbi	LCDPort,LCD_D7	;  D(5)=0
	sbrc	mp,7		; mp(7)=0,  
	sbi	LCDPort,LCD_D7	;  D(5)=1
				;DB6
	sbrs	mp,6		; mp(6)=1,  
	cbi	LCDPort,LCD_D6	;  D(4)=0
	sbrc	mp,6		; mp(6)=0,  
	sbi	LCDPort,LCD_D6	;  D(4)=1
				;DB5
	sbrs	mp,5		; mp(5)=1,  
	cbi	LCDPort,LCD_D5	;  D(3)=0
	sbrc	mp,5		; mp(5)=0,  
	sbi	LCDPort,LCD_D5	;  D(3)=1
				;DB4
	sbrs	mp,4		; mp(4)=1,  
	cbi	LCDPort,LCD_D4	;  D(2)=0
	sbrc	mp,4		; mp(4)=0,  
	sbi	LCDPort,LCD_D4	;  D(2)=1
				;  
				;    
	sbi	LCDPort,LCD_E	;E=1
	rcall	LCD_zadm		; 0,5 
	cbi	LCDPort,LCD_E	;E=0
				;     
				;DB7
	sbrs	mp,3		; mp(3)=1,  
	cbi	LCDPort,LCD_D7	;  D(5)=0
	sbrc	mp,3		; mp(3)=0,  
	sbi	LCDPort,LCD_D7	;  D(5)=1
				;DB6
	sbrs	mp,2		; mp(2)=1,  
	cbi	LCDPort,LCD_D6	;  D(4)=0
	sbrc	mp,2		; mp(2)=0,  
	sbi	LCDPort,LCD_D6	;  D(4)=1
				;DB5
	sbrs	mp,1		; mp(1)=1,  
	cbi	LCDPort,LCD_D5	;  D(3)=0
	sbrc	mp,1		; mp(1)=0,  
	sbi	LCDPort,LCD_D5	;  D(3)=1
				;DB4
	sbrs	mp,0		; mp(0)=1,  
	cbi	LCDPort,LCD_D4	;  D(2)=0
	sbrc	mp,0		; mp(0)=0,  
	sbi	LCDPort,LCD_D4	;  D(2)=1
				;  
				;    
	sbi	LCDPort,LCD_E	;E=1
	rcall	LCD_zadm		; 0,5 
	cbi	LCDPort,LCD_E	;E=0
	ret



;   (  )
; 194 300  = 12 
LCD_zadb:
	ldi	R19,255		; 
LCD_zadb2:		
	ldi	R20,255		;  
LCD_zadb3:
	dec	R20
	cpi	R20,1
	brne	LCD_zadb3		;  
	dec	R19
	cpi	R19,1
	brne	LCD_zadb2		;  
	ret

;   (    )
; 6 300  = 0.4 
LCD_zadm:
	ldi	R19,100		; 
LCD_zadm2:			; 
	ldi	R20,20
LCD_zadm3:
	dec	R20
	cpi	R20,1
	brne	LCD_zadm3		;  
	dec	R19
	cpi	R19,1
	brne	LCD_zadm2		;  
	ret
;-------------------------------
